package com.fp.persistence.pviaticos.param;

import com.fp.dto.hb.Cache;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla VIA_ESTADO*/
@Entity(name="ViaEstado")
@Table(name="VIA_ESTADO")
public class ViaEstado extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable,Cache{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad ViaEstado
*/
@Id
@Column(name="COD_ESTADO" ,nullable=false, updatable=false)
private String pk;
@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Manejo de optimistic locking del registro
*/
private Integer recordversion;

@Column(name="NOM_ESTADO", nullable=true)

/**
* Descripcion default del tipo de tabla de pagos
*/
private String nom_estado;

/**Contructor por defecto*/
public ViaEstado(){
}
/**Contructor de ViaEstado
@param pPk Clave Primaria del entity
*/
public ViaEstado(String pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return ViaEstado
*/
public static ViaEstado find(EntityManager pEntityManager,Object pKey) throws Exception{
    ViaEstado obj = pEntityManager.find(ViaEstado.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de ViaEstado
@return El objeto que referencia a la Clave primaria de ViaEstado
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de ViaEstado
@param pPk El objeto que referencia a la nueva Clave primaria de ViaEstado
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

/**Obtiene el valor de nom_estado
@return valor de nom_estado*/
public String getNom_estado(){
  return nom_estado;
}
/**Fija el valor de nom_estado
@param pNom_estado nuevo Valor de nom_estado*/
public void setNom_estado(String pNom_estado){
  nom_estado=pNom_estado;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof ViaEstado))return false;
    ViaEstado that = (ViaEstado) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad ViaEstado
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco ViaEstado
*/
public Object createInstance(){
 ViaEstado instance=new ViaEstado();	
 return instance;
}
/**Clona la entidad ViaEstado
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  ViaEstado p=(ViaEstado)this.clone();
  return p;
}
}
